unit MyStrings;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, StrUtils;

function Fstr (Getal: Longint): string;
function Fval (Invoer: string): Longint;
function FRealVal (Invoer: string): real;
function BytesView(InpStr: string; Nch: integer): string;
function FormatS31 (Getal: real) : string;
function FormatS33 (Getal: real) : string;
function FormatS38 (Getal: real) : string;
function FormatN30 (Getal: real) : string;
function FormatN80 (Getal: real) : string;
function MyTime: string;
function StrLittleToLong(inpstr: string):longint;
function StrLittleToSignedInt(inpstr: string):integer;
function LongLittleToString(inplong: longint):string;
function IntLittleToString(inpint: integer):string;
function FileExists (Name : String) : boolean;

implementation
//uses u_diagnose;

function Fstr (Getal: Longint): string;
var Temp: string;
begin
str (Getal:7, Temp);
Fstr := Temp;
end;

function Fval (Invoer: string): Longint;
var Temp: Longint;
begin
val (Invoer, Temp);
Fval := Temp;
end;

function FRealVal (Invoer: string): real;
var Temp: real;
begin
val (Invoer, Temp);
FRealVal := Temp;
end;

function BytesView(InpStr: string; Nch: integer): string;
var N, A: integer; Ts, Tt: string;
begin
Ts := ''; Tt := '';
for N := 1 to Nch do
	begin
  A := byte(InpStr[N]);
  str(A:4, Ts);
  Tt := Tt + Ts + ':';
	end;
BytesView := Tt;
end;

function FormatS31 (Getal: real) : string;
var Temp: string;
absGetal : real;
begin
absgetal := abs (Getal);
str(absGetal:5:1, Temp);
if Temp[2] = ' 'then Temp[2] := '0';
if Temp[1] = ' 'then Temp[1] := '0';
if Getal >= 0 then Temp := '+' + Temp else Temp := '- ' + Temp;
FormatS31 := Temp;
end;

function FormatS33 (Getal: real) : string;
var Temp: string;
absGetal : real;
begin
absgetal := abs (Getal);
str(absGetal:7:3, Temp);
if Temp[2] = ' 'then Temp[2] := '0';
if Temp[1] = ' 'then Temp[1] := '0';
if Getal >= 0 then Temp := '+' + Temp else Temp := '-' + Temp;
FormatS33 := Temp;
end;

function FormatS38 (Getal: real) : string;
var Temp: string;
absGetal : real;
begin
absgetal := abs (Getal);
str(absGetal:12:8, Temp);
if Temp[2] = ' 'then Temp[2] := '0';
if Temp[1] = ' 'then Temp[1] := '0';
if Getal >= 0 then Temp := '+' + Temp else Temp := '- ' + Temp;
FormatS38 := Temp;
end;

function FormatN30 (Getal: real) : string;
var Temp: string;
absGetal : real;
begin
absgetal := abs (Getal);
str(absGetal:3:0, Temp);
if Temp[2] = ' 'then Temp[2] := '0';
if Temp[1] = ' 'then Temp[1] := '0';
FormatN30 := Temp;
end;

function FormatN80 (Getal: real) : string;
var Temp: string;
absGetal : real;
begin
absgetal := abs (Getal);
str(absGetal:8:0, Temp);
FormatN80 := Temp;
end;

function MyTime: string;
var h, m, s, ms: word;
T1, T2: string;
begin
decodetime (now, h, m, s, ms);
str(h:2, T1); if h < 10 then T1[1] := '0';
str(m:2, T2); if m < 10 then T2[1] := '0';
MyTime := T1 + ':'+ T2;
end;

function StrLittleToLong(inpstr: string):longint;
var StringOrLong: record
  	case boolean of
      	true: (dummy, Lint: longint);
      	false: (Sint: string[7]);
  	end;
begin
// note string[0] is length byte
StringOrLong.Sint := '...' + InpStr;
StrLittleToLong := StringOrLong.Lint;
end;

function StrLittleToSignedInt(inpstr: string): integer;
var StringOrInt: record
  	case boolean of
      	true: (dummy, Lint: longint);
      	false: (Sint: string[7]);
  	end;
Temp: Longint;
begin
// note string[0] is length byte
StringOrInt.dummy := 0;
StringOrInt.Sint := '...' + InpStr;
Temp := StringOrInt.Lint;
if Temp > 32767 then Temp := Temp - longint(65536);
StrLittleToSignedInt := Temp;
end;

function LongLittleToString(inplong: longint):string;
var StringOrLong: record
  	case boolean of
      	true: (dummy, Lint: longint);
      	false: (Sint: string[7]);
  	end;
begin
// note string[0] is length byte
StringOrLong.Lint := inpLong;
LongLittleToString := midstr(StringOrLong.Sint,4,4);
end;

function IntLittleToString(inpint: integer):string;
var StringOrInt: record
  	case boolean of
      	true: (dummy, NumInt: integer);
      	false: (Sint: string[7]);
  	end;
begin
// note string[0] is length byte
StringOrInt.NumInt := inpint;
IntLittleToString := midstr(StringOrInt.Sint,4,2);
end;

function FileExists (Name : String) : boolean;
Var F : File;
begin
  {$i-}
  Assign (F,Name);
  Reset (F);
  {$I+}
  FileExists:=(IoResult=0) and (Name<>'');
  Close (f);
end;

end.

