unit u_diagnose;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TFrmDiagnose }

  TFrmDiagnose = class(TForm)
    ButtHide: TButton;
    ButtOpslaan: TButton;
    CbxDiagnose: TCheckBox;
    CbxFakeMode: TCheckBox;
    Edit1: TEdit;
    Edit2: TEdit;
    TbxCalY: TEdit;
    TbxCalD: TEdit;
    TbxCalS: TEdit;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    TbxHandwiel: TEdit;
    Label18: TLabel;
    TbxVoedingButtons: TEdit;
    Label17: TLabel;
    TbxEncoderX: TEdit;
    TbxEncoderZ: TEdit;
    Label15: TLabel;
    Label16: TLabel;
    TbxSnelX: TEdit;
    TbxSnelZ: TEdit;
    TbxConnected: TEdit;
    Label14: TLabel;
    TbxUdpRcvError: TEdit;
    TbxUdpSendError: TEdit;
    Label12: TLabel;
    Label13: TLabel;
    TbxMsgInLen: TEdit;
    TbxPwmP: TEdit;
    TbxIP: TEdit;
    TbxMsgOutLen: TEdit;
    TbxMsgInCnt: TEdit;
    TbxMsgOut: TEdit;
    Label10: TLabel;
    Label11: TLabel;
    TbxPwmX: TEdit;
    TbxIX: TEdit;
    TbxPwmZ: TEdit;
    TbxIZ: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    TbxMessage: TEdit;
    TbxMsgOutCnt: TEdit;
    TbxMsgIn: TEdit;
    procedure ButtHideClick(Sender: TObject);
    procedure ButtOpslaanClick(Sender: TObject);
    procedure CbxDiagnoseChange(Sender: TObject);
    procedure CbxFakeModeChange(Sender: TObject);
    procedure TbxCalDChange(Sender: TObject);
    procedure TbxCalSChange(Sender: TObject);
    procedure TbxCalYChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  FrmDiagnose: TFrmDiagnose;

implementation

{$R *.lfm}
uses u_panel, u_tandwielen, MyStrings;

procedure TFrmDiagnose.CbxDiagnoseChange(Sender: TObject);
begin
     Sound_click;
if cbxDiagnose.State = cbChecked then
	RemoteIp := '192.168.2.4' // Stuka
else
  RemoteIp := '192.168.2.40'; // Arduino
SetUpUDP;
end;

procedure TFrmDiagnose.CbxFakeModeChange(Sender: TObject);
begin
  Sound_click;
  if CbxFakeMode.Checked then FakeMode := 1 else FakeMode := 0;
end;

procedure TFrmDiagnose.TbxCalYChange(Sender: TObject);
begin
YstepsPerMicron := fRealVal(TbxCalY.Text);
end;

procedure TFrmDiagnose.TbxCalDChange(Sender: TObject);
begin
DstepsPerMicron := fRealVal(TbxCalD.Text);
end;

procedure TFrmDiagnose.TbxCalSChange(Sender: TObject);
begin
SstepsPerMicron := fRealVal(TbxCalS.Text);
end;

procedure TFrmDiagnose.ButtHideClick(Sender: TObject);
begin
  Sound_click;
  Frmdiagnose.visible := false;
  if TandwielMode then FrmTandwielen.FormStyle := fsStayOnTop else FrmFreesControl.FormStyle := fsStayOnTop;
end;

procedure TFrmDiagnose.ButtOpslaanClick(Sender: TObject);
begin
  Sound_click;
  SchrijfCalibratie;
end;

procedure TFrmDiagnose.FormCreate(Sender: TObject);
begin
  FrmDiagnose.Visible := false;
end;


end.

