unit u_panel;

{$mode objfpc}{$H+}
// Collapse all procedures:  alt shift 1
interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Buttons, Sockets, lnet, lNetComponents, StrUtils, MyStrings;
// Dit programma vereist de Lnet library geïnstalleerd in Lazarus.

type
  t_Axis = (AxNone = 0, AxX, AxY, AxZ, AxD, AxR, AxS);
  t_KoelDebiet = (kdLaag = 0, kdMidden, kdHoog);
  t_SpindelDir = (spDirNormal = 0, spDirReverse);
  t_SpindelMode = (spModeSlow = 0, spModeFast);
  t_SpindelBrake = (spFree = 0, spBrake);
  t_SpindelRun = (spStopped = 0, spRunning);
  t_KoelMode = (kmUit = 0, kmAuto, kmAan);
  t_VoedingMode = (vmNummeriek = 0, vmWiel, vmHandmatig);

{ TFrmFreesControl }
  TFrmFreesControl = class(TForm)
    ButtRecall: TLabel;
    ButtSave: TLabel;
    ButtVoedingMode: TLabel;
    ButtSpindelSpeed1: TLabel;
    ButtSpindelSpeed2: TLabel;
    ButtX: TLabel;
    ButtY: TLabel;
    ButtZ: TLabel;
    ButtD: TLabel;
    ButtR: TLabel;
    ButtS: TLabel;
    ButtSpindelBrake: TLabel;
    Butt1: TLabel;
    Butt2: TLabel;
    Butt3: TLabel;
    Butt4: TLabel;
    Butt5: TLabel;
    Butt6: TLabel;
    Butt7: TLabel;
    Butt8: TLabel;
    Butt9: TLabel;
    ButtAbsolute: TLabel;
    ButtRelative: TLabel;
    Butt0: TLabel;
    ButtPunt: TLabel;
    ButtClr: TLabel;
    ButtPlusMin: TLabel;
    ButtKoelMode: TLabel;
    ButtKoelDebiet: TLabel;
    ButtSpindelDir: TImage;
    ButtVoedingPlus: TImage;
    ButtVoedingMin: TImage;
    ButtDblClk: TLabel;
    TbxXval: TStaticText;
    TbxError: TEdit;
    TbxVoeding: TStaticText;
    TbxPreview: TStaticText;
    TbxTime: TStaticText;
    TbxZval: TStaticText;
    TbxDval: TStaticText;
    TbxSval: TStaticText;
    TbxRval: TStaticText;
    TbxYval: TStaticText;
    TimerDblClick: TTimer;
    TimerBlink: TTimer;
    UdpRcv: TLUDPComponent;
    UdpSend: TLUDPComponent;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    TimerSendMessage: TTimer;

    procedure Butt0Click(Sender: TObject);
    procedure Butt1Click(Sender: TObject);
    procedure Butt2Click(Sender: TObject);
    procedure Butt3Click(Sender: TObject);
    procedure Butt4Click(Sender: TObject);
    procedure Butt5Click(Sender: TObject);
    procedure Butt6Click(Sender: TObject);
    procedure Butt7Click(Sender: TObject);
    procedure Butt8Click(Sender: TObject);
    procedure Butt9Click(Sender: TObject);
    procedure ButtDClick(Sender: TObject);
    procedure ButtRClick(Sender: TObject);
    procedure ButtRecallClick(Sender: TObject);
    procedure ButtSaveClick(Sender: TObject);
    procedure ButtSClick(Sender: TObject);
    procedure ButtSpindelBrakeClick(Sender: TObject);
    procedure ButtRelativeClick(Sender: TObject);
    procedure ButtAbsoluteClick(Sender: TObject);
    procedure ButtClrClick(Sender: TObject);
    procedure ButtDblClkClick(Sender: TObject);
    procedure SetR_asDoelPositie (Hoek: real);
    procedure ButtKoelDebietClick(Sender: TObject);
    procedure ButtKoelModeClick(Sender: TObject);
    procedure ButtPlusMinClick(Sender: TObject);
    procedure ButtPuntClick(Sender: TObject);
    procedure ButtSpindelDirClick(Sender: TObject);
    procedure ButtSpindelSpeed1Click(Sender: TObject);
    procedure ButtSpindelSpeed2Click(Sender: TObject);
    procedure ButtVoedingMinClick(Sender: TObject);
    procedure ButtVoedingPlusClick(Sender: TObject);
    procedure ButtVoedingModeDblClick(Sender: TObject);
    procedure ButtXClick(Sender: TObject);
    procedure ButtXDblClick(Sender: TObject);
    procedure ButtYClick(Sender: TObject);
    procedure ButtYDblClick(Sender: TObject);
    procedure ButtZClick(Sender: TObject);
    procedure ButtZDblClick(Sender: TObject);
    procedure ButtDDblClick(Sender: TObject);
    procedure ButtRDblClick(Sender: TObject);
    procedure ButtSDblClick(Sender: TObject);
    procedure ButtVoedingModeClick(Sender: TObject);
    procedure TbxPreViewClick(Sender: TObject);
    procedure TbxPreViewDblClick(Sender: TObject);
    procedure TbxTimeClick(Sender: TObject);
    procedure TbxTimeDblClick(Sender: TObject);
    procedure TbxDvalClick(Sender: TObject);
    procedure TbxErrorClick(Sender: TObject);
    procedure TbxRvalClick(Sender: TObject);
    procedure TbxRvalDblClick(Sender: TObject);
    procedure TbxSvalClick(Sender: TObject);
    procedure TbxXvalClick(Sender: TObject);
    procedure TbxYvalClick(Sender: TObject);
    procedure TbxZvalClick(Sender: TObject);
    procedure TimerBlinkTimer(Sender: TObject);
    procedure TimerDblClickTimer(Sender: TObject);
    procedure TimerSendMessageTimer(Sender: TObject);
    procedure UdpRcvError(const msg: string; aSocket: TLSocket);
    procedure UdpRcvReceive(aSocket: TLSocket);
    procedure UdpSendError(const msg: string; aSocket: TLSocket);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);

  private

  public
    { public declarations }

    // voor calibratie steppers
  end;

  var
    FrmFreesControl: TFrmFreesControl;
    SpindelMode : t_SpindelMode;
    SpindelDir: t_SpindelDir;
    SpindelRun: t_SpindelRun;
    SpindelBrake: t_SpindelBrake;
    KoelMode: t_KoelMode;
    KoelDebiet: t_KoelDebiet;
    ActieveAs : t_Axis;
    LimitAxisSelect: boolean;
    InvoerGetal: real;
    SaveValue: array[0..15] of LongInt;
    SaveMode: boolean;
    RecallMode: boolean;
    VoedingMode : t_VoedingMode;
    VoedingIndex: byte;
    AbsRelGekozen: boolean;

// voor UDP socket
  const
    RemotePort = 8888;
    LocalPort = 9999;
  var
    RemoteIP: string;
    InMessage  : string;
    CommunicationTimeOut: byte;

// voor As uitlezing en doel
  var
    Xval, Yval, Zval, Dval, Rval, Sval,
    DoelPositie: Longint;
    VoedingSnelheid: integer;
    AsTeNullen: t_Axis;
    PrevAxis: t_Axis = AxX;
    FakeMode: byte;

// voor calibratie Steppers
  const
    CalFileName = 'YDS-calibratie.txt';
    RstepsPerMilliDegree = 0.15; // 1 omw = 4 graden = 600 steps
    YstepsPerMicron: real = 1;
    DstepsPerMicron: real = 1;
    SstepsPerMicron: real = 1;

// voor systeem en controls
  const
    VersieString = '14-08-21';  // in diagnose window
    DataFileName = 'Data.txt';
  var
    TimeDblClk: integer;
    DblClk: boolean;
    SpindelIsAan: boolean;
    VoedingIsAan: boolean;
    Blink: boolean;
    BrakeTimeOut: integer;
    ClearErrors: byte;
    ZeroAll: integer;
    TandwielMode: boolean;
    ZetVoedingAan: boolean;
    sp_normal, sp_black, sp_red : Tpicture;
    {$IFDEF linux}
    ShiftControlsInGroupBoxes: integer;
    {$ENDIF}

// forwards
    procedure WriteData;
    procedure ReadData;
    procedure SetUpUdp;
    procedure SelectAxis (Axis: t_Axis);
    procedure EnableButtons (Yes: boolean);
    procedure SchrijfCalibratie;
    procedure PlayMp3Sound (SoundFileName: string);
    procedure Sound_ding;
    procedure Sound_click;
    procedure FoutBericht (ErrorCode: byte);

implementation
{$R *.lfm}
uses u_diagnose, u_tandwielen, uos_flat;

function iMax (laagste, waarde, hoogste: integer): integer;
begin
iMax := waarde;
if waarde < laagste then iMax := laagste;
if waarde > hoogste then iMax := hoogste;
end;

// Geluiden
procedure PlayMp3Sound (SoundFileName: string);
begin
	uos_CreatePlayer(0);
	uos_AddIntoDevOut(0);
	uos_AddFromFile(0,pchar(SoundFileName));
	uos_Play(0);
end;
procedure Sound_ding;
begin
PlayMp3Sound('ding.mp3');
end;
procedure Sound_click;
begin
PlayMp3Sound('click.mp3');
end;
procedure Sound_logoff;
begin
PlayMp3Sound('logoff.mp3');
end;
// Nummerieke invoer
procedure HighLightAbsRel(HighLight: boolean);
var dColor: TColor;
begin
AbsRelGekozen := not HighLight;
if HighLight then dColor := $000080FF else dColor := clSilver;
with FrmFreesControl do
  begin
  ButtAbsolute.Color := dColor;
  ButtRelative.Color := dColor;
  end;
end;
procedure HighLightDigits (HighLight: boolean);
var dColor: TColor;
begin
if HighLight then dColor := clYellow else dColor := clMedGray;
with FrmFreesControl do
  begin
  Butt1.Color := dColor;
  Butt2.Color := dColor;
  Butt3.Color := dColor;
  Butt4.Color := dColor;
  Butt5.Color := dColor;
  Butt6.Color := dColor;
  Butt7.Color := dColor;
  Butt8.Color := dColor;
  Butt9.Color := dColor;
  ButtX.Color := dColor;
  ButtY.Color := dColor;
  ButtZ.Color := dColor;
  ButtD.Color := dColor;
  ButtR.Color := dColor;
  ButtS.Color := dColor;
  end;
end;
function SaveRecall (Digit:byte): boolean;
begin
SaveRecall := false;
if SaveMode then
   begin
   Sound_click;
   if Digit <= 9 then
   		SaveValue[Digit] := trunc(InvoerGetal*10000)
   else
      SaveValue[Digit] := SaveValue[0]*10;
   HighLightDigits (false);
   SaveMode := false;
   SaveRecall := true;
   WriteData;
   exit;
   end;
if RecallMode then
   begin
   Sound_click;
   InvoerGetal := SaveValue[Digit]/10000;
   FrmFreesControl.TbxPreView.caption := FormatS33(InvoerGetal);
   HighLightDigits (false);
   RecallMode := false;
   SaveRecall := true;
   exit;
   end;
end;
procedure AddToInvoer (Cijfer: string);
label Show;
const
  Ndecimals : integer = 0;
  Invoer: string = '';
  PuntGezien: boolean = false;
  InvoerPol : integer = 1;
begin
Sound_click;
if Cijfer = 'C' then begin Invoer := ''; InvoerPol := 1; PuntGezien := false; Ndecimals := 0; goto Show; end;
if Cijfer = '.' then
   begin
   if PuntGezien then begin Sound_ding; goto Show; end else PuntGezien := true;
   end;
if cijfer = '-' then begin InvoerPol := InvoerPol * -1; goto Show; end;
if length(InVoer) = 3 then
   begin
   if not PuntGezien then begin Sound_ding; goto show; end;
   end;
if length(InVoer) = 7 then begin Sound_ding; goto Show; end; // max 7 tekens incl punt
if Ndecimals > 3 then begin Sound_ding; goto show; end;
Invoer := Invoer + Cijfer;
if PuntGezien then inc(Ndecimals);
Show:
Invoergetal := FRealVal (Invoer)* InVoerPol;
FrmFreesControl.TbxPreView.caption := FormatS33(InvoerGetal);
DoelPositie := round(InvoerGetal*1000); // default absolute
HighlightAbsRel (true);
end;
procedure TFrmFreesControl.Butt0Click(Sender: TObject);
begin
AddToInvoer('0');
end;
procedure TFrmFreesControl.Butt1Click(Sender: TObject);
begin
if not SaveRecall(1) then AddToInvoer('1');
end;
procedure TFrmFreesControl.Butt2Click(Sender: TObject);
begin
if not SaveRecall(2) then AddToInvoer('2');
end;
procedure TFrmFreesControl.Butt3Click(Sender: TObject);
begin
if not SaveRecall(3) then AddToInvoer('3');
end;
procedure TFrmFreesControl.Butt4Click(Sender: TObject);
begin
if not SaveRecall(4) then AddToInvoer('4');
end;
procedure TFrmFreesControl.Butt5Click(Sender: TObject);
begin
if not SaveRecall(5) then AddToInvoer('5');
end;
procedure TFrmFreesControl.Butt6Click(Sender: TObject);
begin
if not SaveRecall(6) then AddToInvoer('6');
end;
procedure TFrmFreesControl.Butt7Click(Sender: TObject);
begin
if not SaveRecall(7) then AddToInvoer('7');
end;
procedure TFrmFreesControl.Butt8Click(Sender: TObject);
begin
if not SaveRecall(8) then AddToInvoer('8');
end;
procedure TFrmFreesControl.Butt9Click(Sender: TObject);
begin
if not SaveRecall(9) then AddToInvoer('9');
end;
procedure TFrmFreesControl.ButtXClick(Sender: TObject);
begin
if DblClk then begin ButtXDblClick (Sender); exit; end;
SaveValue[0] := Xval;
SaveRecall(10);
end;
procedure TFrmFreesControl.ButtYClick(Sender: TObject);
begin
if DblClk then begin ButtYDblClick (Sender); exit; end;
SaveValue[0] := Yval;
SaveRecall(11);
end;
procedure TFrmFreesControl.ButtZClick(Sender: TObject);
begin
if DblClk then begin ButtZDblClick (Sender); exit; end;
SaveValue[0] := Zval;
SaveRecall(12);
end;
procedure TFrmFreesControl.ButtDClick(Sender: TObject);
begin
if DblClk then begin ButtDDblClick (Sender); exit; end;
SaveValue[0] := Dval;
SaveRecall(13);
end;
procedure TFrmFreesControl.ButtRClick(Sender: TObject);
begin
if DblClk then begin ButtRDblClick (Sender); exit; end;
SaveValue[0] := Rval;
SaveRecall(14);
end;
procedure TFrmFreesControl.ButtSClick(Sender: TObject);
begin
if DblClk then begin ButtSDblClick (Sender); exit; end;
SaveValue[0] := Sval;
SaveRecall(15);
end;
procedure TFrmFreesControl.ButtAbsoluteClick(Sender: TObject);
begin
  Sound_click;
  AbsRelGekozen := true;
  DoelPositie := round(InvoerGetal*1000);
  with FrmFreesControl do
  begin
    TbxPreView.caption := FormatS33(DoelPositie / 1000);
    ButtRelative.color := clscrollbar;
    ButtAbsolute.color := clLime;
  end;
end;
procedure TFrmFreesControl.ButtRelativeClick(Sender: TObject);
begin
  Sound_click;
  AbsRelGekozen := true;
  case ActieveAs of
  AxX: DoelPositie := Xval + round(InvoerGetal*1000);
  AxY: DoelPositie := Yval + round(InvoerGetal*1000);
  AxZ: DoelPositie := Zval + round(InvoerGetal*1000);
  AxD: DoelPositie := Dval + round(InvoerGetal*1000);
  AxR: DoelPositie := Rval + round(InvoerGetal*1000);
  AxS: DoelPositie := Sval + round(InvoerGetal*1000);
  end;
  with FrmFreesControl do
  begin
  TbxPreView.caption := FormatS33(DoelPositie / 1000);
  ButtRelative.color := clLime;
  ButtAbsolute.color := clscrollbar;
  end;
end;
procedure TFrmFreesControl.ButtPlusMinClick(Sender: TObject);
begin
AddToInvoer ('-');
end;
procedure TFrmFreesControl.ButtPuntClick(Sender: TObject);
begin
AddToInvoer ('.');
end;
procedure TFrmFreesControl.ButtClrClick(Sender: TObject);
begin
AddToInvoer ('C');
end;
procedure TFrmFreesControl.ButtRecallClick(Sender: TObject);
begin
Sound_click;
HighlightAbsRel (true);
if SaveMode or RecallMode then
   begin
   SaveMode := false;
   RecallMode := false;
   HighLightDigits (false);
   exit;
   end;
RecallMode := true;
SaveMode := false;
HighLightDigits (true);
end;
procedure TFrmFreesControl.ButtSaveClick(Sender: TObject);
begin
Sound_click;
if SaveMode or RecallMode then
   begin
   SaveMode := false;
   RecallMode := false;
   HighLightDigits (false);
   exit;
   end;
SaveMode := true;
RecallMode := false;
HighLightDigits (true);
end;
procedure EnableButtons (Yes: boolean);
begin
with FrmFreesControl do
  begin
	Butt1.Enabled := Yes;
	Butt2.Enabled := Yes;
	Butt3.Enabled := Yes;
	Butt4.Enabled := Yes;
	Butt5.Enabled := Yes;
	Butt6.Enabled := Yes;
	Butt7.Enabled := Yes;
  Butt8.Enabled := Yes;
  Butt9.Enabled := Yes;
  Butt0.Enabled := Yes;
  ButtPunt.Enabled := Yes;
  ButtSave.Enabled := Yes;
  ButtRecall.Enabled := Yes;
  ButtClr.Enabled := Yes;
	ButtPlusMin.Enabled := Yes;
	ButtRelative.Enabled := Yes;
  ButtAbsolute.Enabled := Yes;
  end;
end;

// Koelmiddel
procedure TFrmFreesControl.ButtKoelDebietClick(Sender: TObject);
const PrevKoelDebiet: t_KoelDebiet = kdLaag;
begin
Sound_click;
case KoelDebiet of
  kdLaag:
    begin
    PrevKoelDebiet := kdLaag;
    KoelDebiet := kdMidden;
    ButtKoelDebiet.Caption := 'M';
    end;
  kdMidden:
    begin
    	if PrevKoelDebiet = kdLaag then
    	begin
    		Koeldebiet := kdHoog;
        PrevKoelDebiet := kdHoog;
    		ButtKoelDebiet.Caption := 'H';
    	end
    	else //if PrevKoelDebiet = kdHoog then
    	begin
    		KoelDebiet := kdLaag;
        PrevKoelDebiet := kdLaag;
    		ButtKoelDebiet.Caption := 'L';
    	end;
  	end;
  kdHoog:
    begin
    PrevKoelDebiet := kdHoog;
    Koeldebiet := kdMidden;
    ButtKoelDebiet.Caption := 'M';
    end;
  end;
end;
procedure TFrmFreesControl.ButtKoelModeClick(Sender: TObject);
begin
Sound_click;
case KoelMode of
  kmUit:
    begin
    KoelMode := kmAuto;
    ButtKoelMode.Caption := 'Auto';
    end;
  kmAuto:
    begin
    KoelMode := kmAan;
    ButtKoelMode.Caption := 'Aan';
    end;
  kmAan:
    begin
    KoelMode := kmUit;
    ButtKoelMode.Caption := 'Uit';
    end;
  end;
end;

// Voeding
procedure TFrmFreesControl.ButtVoedingModeClick(Sender: TObject);
begin
if DblClk then begin ButtVoedingModeDblClick (Sender); exit; end;
if TandwielMode then begin Sound_ding; exit; end; // VoedingMode veranderen is verboden
Sound_click;
if VoedingMode = vmNummeriek then
  begin
  VoedingMode := vmWiel;
  ButtVoedingMode.caption := 'Wiel';
  EnableButtons (false);
  LimitAxisSelect := false;
  exit;
  end;
if (VoedingMode = vmWiel) or (VoedingMode = vmHandmatig) then
  begin
  VoedingMode := vmNummeriek;
  ButtVoedingMode.caption := 'Num';
  LimitAxisSelect := false;
  EnableButtons (true);
  end;
end;
procedure TFrmFreesControl.ButtVoedingModeDblClick(Sender: TObject);
begin
if TandwielMode then begin Sound_ding; exit; end; // VoedingMode veranderen is verboden
Sound_click;
VoedingMode := vmHandmatig;
ButtVoedingMode.caption := 'Hand matig';
LimitAxisSelect := true;
if (ActieveAs <> AxR) and (ActieveAs <> AxS) then ActieveAs := AxR;
SelectAxis (ActieveAs);
EnableButtons (true);
end;
procedure EvalVoedingIndex (VoedingIndex:byte);
Begin
if VoedingIndex = 0 then VoedingSnelheid := 5;
if VoedingIndex = 1 then VoedingSnelheid := 10;
if VoedingIndex = 2 then VoedingSnelheid := 20;
if VoedingIndex = 3 then VoedingSnelheid := 50;
if VoedingIndex = 4 then VoedingSnelheid := 100;
if VoedingIndex = 5 then VoedingSnelheid := 200;
if VoedingIndex = 6 then VoedingSnelheid := 500;
FrmFreesControl.TbxVoeding.caption := FormatN30(VoedingSnelheid);
end;
procedure TFrmFreesControl.ButtVoedingPlusClick(Sender: TObject);
begin
  if VoedingIndex < 6 then inc(VoedingIndex) else begin Sound_ding; exit; end;
  Sound_click;
  EvalVoedingIndex (VoedingIndex);
end;
procedure TFrmFreesControl.ButtVoedingMinClick(Sender: TObject);
begin
  if VoedingIndex > 0 then dec(VoedingIndex) else begin Sound_ding; exit; end;
  Sound_click;
  EvalVoedingIndex (VoedingIndex);
end;

// Spindel
procedure EvalSpindelState;
// called at receive message and at button change
const PrevSpindelIsAan : boolean = false;
begin with FrmFreesControl do
  begin
  // switch off normal direction after run
  if PrevSpindelIsAan and not SpindelIsAan then SpindelDir := spDirNormal;
	PrevSpindelIsAan := SpindelIsAan;
	if SpindelDir = spDirNormal then
  	begin
    ButtSpindelDir.picture := sp_normal;
  	end
	else      // spDirReverse
		begin
   	 // ButtSpindelDir.Caption:='Q';  // pijl linksom in WingDings 3 font
   	 if Blink then ButtSpindelDir.picture := sp_red else ButtSpindelDir.picture := sp_black;
 		end;
  if SpindelIsAan then SpindelBrake := spFree;
  if SpindelBrake = spBrake then
      ButtSpindelBrake.Color := clRed
  else
      ButtSpindelBrake.Color := clGray;
  case SpindelMode of
    spModeSlow:
      begin
      ButtSpindelSpeed1.Color := clLime;
      ButtSpindelSpeed2.Color := clGray;
      end;
    spModeFast:
      begin
      ButtSpindelSpeed1.Color := clGray;
      ButtSpindelSpeed2.Color := clLime;
      end;
    end; // case
  ButtSpindelDir.Enabled := not SpindelIsAan;
  ButtSpindelSpeed1.enabled := not SpindelIsAan;
  ButtSpindelSpeed2.Enabled := not SpindelIsAan;
  ButtSpindelBrake.enabled := not SpindelIsAan;
  end; // with
end;
procedure TFrmFreesControl.ButtSpindelDirClick(Sender: TObject);
begin
  Sound_click;
  SpindelMode := spModeSlow;
	if SpindelDir = spDirNormal then
    begin
    SpindelDir := spDirReverse;
    SpindelBrake := spFree;
    end
  else
    SpindelDir := spDirNormal;
EvalSpindelState;
end;
procedure TFrmFreesControl.ButtSpindelSpeed1Click(Sender: TObject);
begin
  Sound_click;
 	SpindelDir := spDirNormal;
  SpindelMode := spModeSlow;
  SpindelBrake := spFree;
	EvalSpindelState;
end;
procedure TFrmFreesControl.ButtSpindelSpeed2Click(Sender: TObject);
begin
  Sound_click;
 	Spindeldir := spDirNormal;
  SpindelMode := spModeFast;
  SpindelBrake := spFree;
  EvalSpindelState;
end;
procedure TFrmFreesControl.ButtSpindelBrakeClick(Sender: TObject);
begin
  Sound_click;
  Spindeldir := spDirNormal;
  if SpindelBrake = spFree then
    begin
    SpindelBrake := spBrake;
    BrakeTimeOut := 1000; // 3 sec per count = 5 min
    end
  else
  SpindelBrake := spFree;
  EvalSpindelState;
end;
function SpindelControl: byte;
begin
if SpindelDir = spDirReverse then  exit(2);
if SpindelBrake = spBrake then exit (4);
if SpindelMode = spModeSlow then exit (1);
if SpindelMode = spModeFast then exit (3);
end;

// As Selecteren
procedure SelectAxis (Axis: t_Axis);
begin
if TandwielMode then begin Sound_ding; exit; end; // actieve as veranderen is verboden
if LimitAxisSelect then if (Axis <> AxR) and (Axis <> AxS) then begin Sound_ding; exit; end;
Sound_click;
ActieveAs := Axis;
with FrmFreesControl do
begin
  TbxXval.Font.Color := clRed;
  TbxYval.Font.Color := clRed;
  TbxZval.Font.Color := clRed;
  TbxDval.Font.Color := clRed;
  TbxRval.Font.Color := clRed;
  TbxSval.Font.Color := clRed;
  case Axis of
    AxX: TbxXval.Font.Color := clLime;
    AxY: TbxYval.Font.Color := clLime;
    AxZ: TbxZval.Font.Color := clLime;
    AxD: TbxDval.Font.Color := clLime;
    AxR: TbxRval.Font.Color := clLime;
    AxS: TbxSval.Font.Color := clLime;
  end;
  TbxPreView.caption := FormatS33(InvoerGetal);
end;
if PrevAxis <> Axis then
  begin
  HighlightAbsRel (true);
  PrevAxis := Axis;
  end;
end;
procedure TFrmFreesControl.TbxXvalClick(Sender: TObject);
begin
if VoedingIsAan or LimitAxisSelect then begin Sound_ding; exit; end; // actieve as veranderen is verboden
SelectAxis (AxX);
end;
procedure TFrmFreesControl.TbxYvalClick(Sender: TObject);
begin
if VoedingIsAan  or LimitAxisSelect then begin Sound_ding; exit; end; // actieve as veranderen is verboden
SelectAxis (AxY);
end;
procedure TFrmFreesControl.TbxZvalClick(Sender: TObject);
begin
if VoedingIsAan  or LimitAxisSelect then begin Sound_ding; exit; end; // actieve as veranderen is verboden
SelectAxis (AxZ);
end;
procedure TFrmFreesControl.TbxDvalClick(Sender: TObject);
begin
if VoedingIsAan  or LimitAxisSelect then begin Sound_ding; exit; end; // actieve as veranderen is verboden
SelectAxis (AxD);
end;
procedure TFrmFreesControl.TbxRvalClick(Sender: TObject);
begin
if DblClk then begin TbxRvalDblClick(Sender); exit; end;
if VoedingIsAan then begin Sound_ding; exit; end; // actieve as veranderen is verboden
SelectAxis (AxR);
end;
procedure TFrmFreesControl.TbxRvalDblClick(Sender: TObject);  // DblClk = Tandwiel dialoog
begin
if VoedingIsAan then begin Sound_ding; exit; end; // actieve as veranderen is verboden
if DoelPositie < 2000 then begin Sound_ding; FoutBericht (20); exit; end; // eerst aantal tanden opgeven, 2+
if VoedingMode <> vmNummeriek then begin Sound_ding; exit; end; // moet nummeriek zijn
Sound_click;
SelectAxis (AxR);
with FrmTandwielen do
  begin
  Top := 662;
  Left := 150;
  Visible := true;
  FormStyle := fsSystemStayOnTop;
  SetAantalTanden (round(DoelPositie /1000));
  end;
EnableButtons (false);
TandwielMode := true;
VoedingIndex := 6;      // hoogste snelheid voeding draaitafel
EvalVoedingIndex (VoedingIndex);
AsTeNullen := AxR;
FormStyle := fsNormal;
end;
procedure TFrmFreesControl.TbxSvalClick(Sender: TObject);
begin
if VoedingIsAan then begin Sound_ding; exit; end; // actieve as veranderen is verboden
SelectAxis (AxS);
end;

// As Nullen
procedure TFrmFreesControl.ButtXDblClick(Sender: TObject);
begin
if VoedingIsAan then begin Sound_ding; exit; end; // nullen of actieve as veranderen is verboden
if not TandwielMode then SelectAxis (AxX) else Sound_click;
AsTeNullen := AxX;
end;
procedure TFrmFreesControl.ButtYDblClick(Sender: TObject);
begin
if VoedingIsAan then begin Sound_ding; exit; end; // nullen of actieve as veranderen is verboden
if not TandwielMode then SelectAxis (AxY) else Sound_click;
AsTeNullen := AxY;
end;
procedure TFrmFreesControl.ButtZDblClick(Sender: TObject);
begin
if VoedingIsAan then begin Sound_ding; exit; end; // nullen of actieve as veranderen is verboden
if not TandwielMode then SelectAxis (AxZ) else Sound_click;
AsTeNullen := AxZ;
end;
procedure TFrmFreesControl.ButtDDblClick(Sender: TObject);
begin
if VoedingIsAan then begin Sound_ding; exit; end; // nullen of actieve as veranderen is verboden
if not TandwielMode then SelectAxis (AxD) else Sound_click;
AsTeNullen := AxD;
end;
procedure TFrmFreesControl.ButtRDblClick(Sender: TObject);
begin
if VoedingIsAan then begin Sound_ding; exit; end; // nullen of actieve as veranderen is verboden
if not TandwielMode then SelectAxis (AxR) else Sound_click;
AsTeNullen := AxR;
end;
procedure TFrmFreesControl.ButtSDblClick(Sender: TObject);
begin
if VoedingIsAan then begin Sound_ding; exit; end; // nullen of actieve as veranderen is verboden
if not TandwielMode then SelectAxis (AxS) else Sound_click;
AsTeNullen := AxS;
end;

// Fout- Status meldingen
procedure ToonFout (Message: string);
begin
with FrmFreesControl do
  begin
  	TbxError.text := Message;
  	if Message = 'Ok' then
  		TbxError.Font.Color:= clLime
  	else
 			if Blink then TbxError.Font.Color:= $00CCFF else TbxError.Font.Color:= $000000;
  end;
end;
procedure FoutBericht (ErrorCode: byte);
// prioriteit van meldingen is geregeld in de Arduino
begin
case ErrorCode of
  0: ToonFout ('Ok');
  5: ToonFout ('Nood STOP is ingedrukt');
  10: ToonFout ('Schakel Drive Power in');
  20: ToonFout ('Aantal tanden opgeven');
  50: ToonFout ('Fout in X-liniaal');
  55: ToonFout ('Fout in Z-liniaal');
  60: ToonFout ('Geen communicatie met Linialen');
  71: ToonFout ('Overstroom X');
  72: ToonFout ('Overstroom Z');
  73: ToonFout ('Overstroom KoelPomp');
  200: ToonFout ('Fake Mode');
  255: ToonFout ('Geen Communicatie met Machine');
  else ToonFout ('Onbekende fout');
  end;
end;
procedure TFrmFreesControl.TbxErrorClick(Sender: TObject);
begin
  Sound_click;
  ClearErrors := 1;
end;

// UDP communicatie
procedure TFrmFreesControl.TimerSendMessageTimer(Sender: TObject);
const Ticks: longint = 2;
var OutMessage: shortstring;
var i: integer;
begin
TbxTime.caption := MyTime;
OutMessage := char($AA);
case ActieveAs of
  // Traject waardes zijn in micron voor X en Z,
  // in motorsteps voor Y, D en S,
  // in duizendste graad voor R
  // Voedingssnelheid is in mm/min voor X en Z,
  // in motorsteps per seconde voor de steppers.
  // De omrekening en calibratie gebeurt dus hier.
  AxX, AxZ:
  begin
    OutMessage := OutMessage + LongLittleToString (DoelPositie);
    OutMessage := OutMessage + IntLittleToString (VoedingSnelheid);
  end;
  AxY:
  begin
    OutMessage := OutMessage + LongLittleToString (round(DoelPositie * YstepsPerMicron));
    OutMessage := OutMessage + IntLittleToString (round(iMax(0,VoedingSnelheid,50) / 60 * YstepsPerMicron * 1000));
    FrmDiagnose.Edit2.text := fstr (round(VoedingSnelheid / 60 *YstepsPerMicron * 1000));
  end;
  AxD:
  begin
    OutMessage := OutMessage + LongLittleToString (round(DoelPositie * DstepsPerMicron));
    OutMessage := OutMessage + IntLittleToString (round(VoedingSnelheid / 60 * DstepsPerMicron * 1000));
    FrmDiagnose.Edit2.text := fstr (round(VoedingSnelheid / 60 * DstepsPerMicron * 1000));
  end;
  AxR:
  begin
    OutMessage := OutMessage + LongLittleToString (round(DoelPositie * RstepsPerMilliDegree));
    OutMessage := OutMessage + IntLittleToString (round(VoedingSnelheid / 60 * RstepsPerMilliDegree * 1000));
    FrmDiagnose.Edit2.text := fstr (round(VoedingSnelheid / 60 * RstepsPerMilliDegree * 1000));
  end;
  AxS:
  begin
    OutMessage := OutMessage + LongLittleToString (round(DoelPositie * SstepsPerMicron));
    OutMessage := OutMessage + IntLittleToString (round(VoedingSnelheid / 60 * SstepsPerMicron * 1000));
    FrmDiagnose.Edit2.text := fstr(round(VoedingSnelheid / 60 * SstepsPerMicron * 1000));
  end;
end; // case
OutMessage[8] := char(ActieveAs);
OutMessage[9] := char(SpindelControl);
OutMessage[10] := char(KoelMode);
OutMessage[11] := char(KoelDebiet);
OutMessage[12] := char(AsTeNullen);
OutMessage[13] := char(ord(VoedingMode));
OutMessage[14] := char(FakeMode);
OutMessage[15] := char(ClearErrors);
if ZetVoedingAan then OutMessage[16] := char(1) else OutMessage[16] := char(0);
ZetVoedingAan := false;
for i := 17 to 29 do  OutMessage[i] := char(0); // padding
OutMessage[0] := char(29);  // length byte
FrmDiagnose.TbxMsgOut.text := BytesView(OutMessage, 20);
UdpSend.SendMessage (OutMessage);
ClearErrors := 0;  // 1-malig
AsTeNullen := AxNone;  // 1-malig
inc (Ticks);
FrmDiagnose.TbxMsgOutCnt.text := Fstr(Ticks);
FrmDiagnose.TbxMsgOutLen.text := Fstr(length(OutMessage));
TbxTime.caption := MyTime;
if CommunicationTimeOut > 0 then dec(CommunicationTimeOut)
  else FoutBericht(255);
end;
procedure TFrmFreesControl.UdpSendError(const msg: string; aSocket: TLSocket);
begin
FrmDiagnose.TbxUdpSendError.text := 'error' + msg;
asocket := asocket;
end;
procedure TFrmFreesControl.UdpRcvReceive(aSocket: TLSocket);
// Interrupt handler for incoming messages
const InCount: integer = 0;
begin
inc(Incount);
FrmDiagnose.TbxMsgInCnt.Text := Fstr(InCount);
if aSocket.GetMessage(InMessage) > 0 then
	begin
  Xval := StrLittleToLong (midstr(InMessage,2,4));
  Yval := StrLittleToLong (midstr(InMessage,6,4));
  if FakeMode = 1 then Yval := round(Yval / YstepsPerMicron);
  Zval := StrLittleToLong (midstr(InMessage,10,4));
  Dval := StrLittleToLong (midstr(InMessage,14,4));
  if FakeMode = 1 then Dval := round(Dval / DstepsPerMicron);
  Rval := StrLittleToLong (midstr(InMessage,18,4));
  // R is always derived from the StepCounter
  Rval := round(Rval / RstepsPerMilliDegree);
  Sval := StrLittleToLong (midstr(InMessage,22,4));
  if FakeMode = 1 then Sval := round(Sval / SstepsPerMicron);
  TbxXval.caption := FormatS33(Xval/1000);
  TbxYval.caption := FormatS33(Yval/1000);
  TbxZval.caption := FormatS33(Zval/1000);
  TbxDval.caption := FormatS33(Dval/1000);
  TbxRval.caption := FormatS33(Rval/1000);
  TbxSval.caption := FormatS33(Sval/1000);
  FoutBericht (byte(InMessage[26]));
  SpindelIsAan := byte(InMessage[27]) = 1;
  VoedingIsAan := byte(InMessage[28]) = 1;
  with FrmDiagnose do
    begin
  	TbxMsgInLen.text := Fstr(Length(InMessage));
  	TbxMsgIn.text := bytesview(midstr(InMessage,33,10),10);
    TbxSnelX.text := FormatS31(StrLittleToSignedInt(midstr(InMessage,29,2))/10);
    TbxSnelZ.text := FormatS31(StrLittleToSignedInt(midstr(InMessage,31,2))/10);
    TbxPwmX.text := Fstr(StrLittleToSignedInt(midstr(InMessage,33,2)));
    TbxPwmZ.text := Fstr(StrLittleToSignedInt(midstr(InMessage,35,2)));
    TbxPwmP.text := Fstr(StrLittleToSignedInt(midstr(InMessage,37,2)));
    TbxHandwiel.text := FormatN80(StrLittleToLong (midstr(InMessage,39,4)));
    TbxIX.text := FormatS33(StrLittleToSignedInt(midstr(InMessage,65,2))/1000);
    TbxIZ.text := FormatS33(StrLittleToSignedInt(midstr(InMessage,67,2))/1000);
    TbxIP.text := FormatS33(StrLittleToSignedInt(midstr(InMessage,69,2))/1000);
    TbxVoedingButtons.text := Fstr(longint(InMessage[81]));
    TbxEncoderX.text := FormatS33(StrLittleToLong (midstr(InMessage,82,4))/1000);
    TbxEncoderZ.text := FormatS33(StrLittleToLong (midstr(InMessage,86,4))/1000);
    Edit2.text := Fstr(StrLittleToSignedInt(midstr(InMessage,90,2)));
    end;
  ButtVoedingMode.Enabled := not VoedingIsAan;
  if VoedingIsAan then ButtVoedingMode.Color:= clDefault else ButtVoedingMode.Color:= clYellow;
  if VoedingIsAan or (VoedingMode = vmWiel) or TandwielMode then EnableButtons (false) else EnableButtons(true);
  if (not AbsRelGekozen) and VoedingIsAan then
    begin
    ButtRelative.color := clscrollbar;
    ButtAbsolute.color := clLime;
    end;
  end;
EvalSpindelState;
CommunicationTimeOut := 20; // ca. 2 sec
end;
procedure TFrmFreesControl.UdpRcvError(const msg: string; aSocket: TLSocket);
begin
FrmDiagnose.TbxUdpRcvError.text := 'Error: '+ msg;
asocket := asocket;
end;
procedure SetUpUDP;
begin
FrmFreesControl.UdpSend.Connect(RemoteIp, RemotePort);
if (FrmFreesControl.UdpRcv.listen(LocalPort)) then
	FrmDiagnose.TbxConnected.text := 'true' else FrmDiagnose.TbxConnected.text := 'false';
end;

// Diversen
procedure TFrmFreesControl.SetR_asDoelPositie (Hoek: real); // Voor tandwiel frezen
begin
DoelPositie := round(Hoek * 1000);
FrmFreesControl.TbxPreView.caption := FormatS33(DoelPositie/1000);
end;
procedure TFrmFreesControl.TbxPreViewClick(Sender: TObject);
begin
if DblClk then begin TbxPreViewDblClick(Sender); exit; end;
end;
procedure TFrmFreesControl.TbxPreViewDblClick(Sender: TObject); // Diagnose
begin
Sound_click;
with FrmDiagnose do
  begin
  Top := 100;
  Left := 100;
  Visible := true;
  FormStyle := fsStayOnTop;
  end;
FormStyle := fsNormal;
end;
procedure TFrmFreesControl.TimerBlinkTimer(Sender: TObject);
begin
	if ZeroAll > 0 then
  begin
  	FrmDiagnose.visible := false;
    case ZeroAll of
      9: ButtSDblClick(Sender);
      8: ButtRDblClick(Sender);
      7: ButtDDblClick(Sender);
      6: ButtZDblClick(Sender);
      5: ButtYDblClick(Sender);
      4: ButtXDblClick(Sender);
    end;
    dec(ZeroAll);
  end;
  Blink := not Blink;
  if SpindelIsAan then BrakeTimeOut := 0;
  EvalSpindelState;
  if BrakeTimeOut > 0 then begin dec(BrakeTimeOut); exit; end;
  SpindelBrake := spFree;
end;
procedure TFrmFreesControl.TimerDblClickTimer(Sender: TObject);
begin
if TimeDblClk > 0 then
	begin
	DblClk := true;
	dec(TimeDblClk);
	ButtDblClk.Color := clred;
	end
else
	begin
  DblClk := false;
	ButtDblClk.Color := clgreen;
  end;
end;
procedure TFrmFreesControl.ButtDblClkClick(Sender: TObject);
begin
TimeDblClk := 30;  // seconds/20
end;

// Files
procedure ReadData;
var DataFile : text;
i : integer;
begin
if not FileExists (DataFileName) then exit;
assign (DataFile, DataFileName);
reset (DataFile);
for i := 1 to 15 do
  readln (datafile, SaveValue[i]);
close (DataFile);
end;
procedure WriteData;
var DataFile : text;
i : integer;
begin
assign (DataFile, DataFileName);
rewrite (DataFile);
for i := 1 to 15 do
  writeln (DataFile, SaveValue[i]);
close (DataFile);
end;
procedure SchrijfCalibratie;
var DataFile : text;
begin
  assign (DataFile, CalFileName);
  rewrite (DataFile);
  writeln (DataFile, YstepsPerMicron);
  writeln (DataFile, DstepsPerMicron);
  writeln (DataFile, SstepsPerMicron);
  close (DataFile);
end;
procedure LeesCalibratie;
var DataFile : text;
begin
  assign (DataFile, CalFileName);
  reset (DataFile);
  readln (DataFile, YstepsPerMicron);
  readln (DataFile, DstepsPerMicron);
  readln (DataFile, SstepsPerMicron);
  close (DataFile);
  with FrmDiagnose do
  begin
    TbxCalY.Text := FormatS38(YstepsPerMicron);
    TbxCalD.Text := FormatS38(DstepsPerMicron);
    TbxCalS.Text := FormatS38(SstepsPerMicron);
  end;
end;

// Init, Exit
procedure HideCursors (Hide:boolean);
var CursorType: integer;
begin
if Hide then CursorType := crNone else CursorType := crDefault;
with FrmFreesControl do
  begin
  Cursor := CursorType;
  TbxError.Cursor := crNone;
  ButtX.Cursor := CursorType;
  ButtY.Cursor := CursorType;
  ButtZ.Cursor := CursorType;
  ButtD.Cursor := CursorType;
  ButtR.Cursor := CursorType;
  ButtS.Cursor := CursorType;
  ButtX.Cursor := CursorType;
  TbxXval.Cursor := CursorType;
  TbxYval.Cursor := CursorType;
  TbxZval.Cursor := CursorType;
  TbxDval.Cursor := CursorType;
  TbxRval.Cursor := CursorType;
  TbxSval.Cursor := CursorType;
  TbxTime.Cursor := CursorType;
  ButtRecall.Cursor := CursorType;
  ButtSave.Cursor := CursorType;
  GroupBox2.Cursor := CursorType;
  ButtKoelMode.Cursor := CursorType;
  ButtKoelDebiet.Cursor := CursorType;
  GroupBox4.Cursor := CursorType;
  TbxVoeding.Cursor := CursorType;
  ButtVoedingPlus.Cursor := CursorType;
  ButtVoedingMin.Cursor := CursorType;
  ButtVoedingMode.Cursor := CursorType;
  GroupBox3.Cursor := CursorType;
  ButtSpindelDir.Cursor := CursorType;
  ButtSpindelSpeed1.Cursor := CursorType;
  ButtSpindelSpeed2.Cursor := CursorType;
  ButtSpindelBrake.Cursor := CursorType;
  TbxPreView.Cursor := CursorType;
  TbxSval.Cursor := CursorType;
  TbxSval.Cursor := CursorType;
  TbxSval.Cursor := CursorType;
  Butt7.Cursor := CursorType;
  Butt8.Cursor := CursorType;
  Butt9.Cursor := CursorType;
  ButtClr.Cursor := CursorType;
  Butt4.Cursor := CursorType;
  Butt5.Cursor := CursorType;
  Butt6.Cursor := CursorType;
  ButtPlusMin.Cursor := CursorType;
  Butt1.Cursor := CursorType;
  Butt2.Cursor := CursorType;
  Butt3.Cursor := CursorType;
  ButtAbsolute.Cursor := CursorType;
  Butt0.Cursor := CursorType;
  ButtPunt.Cursor := CursorType;
  ButtRelative.Cursor := CursorType;
  end;
with  FrmTandwielen do
  begin
  Cursor := CursorType;
  ButtVorigeTand.Cursor := CursorType;
  ButtVolgendeTand.Cursor := CursorType;
  TbxTandTemaken.Cursor := CursorType;
  TbxAantalTanden.Cursor := CursorType;
  end;
end;
procedure TFrmFreesControl.TbxTimeDblClick(Sender: TObject); // Exit Program
begin
  Sound_logoff;
  sleep (2000); // tijd om het geluidje af te maken.
  halt;
end;
procedure InitAudio;
var
  PA_FileName, MP_FileName, ordir : string;
begin
  ordir := IncludeTrailingBackslash(ExtractFilePath(ParamStr(0)));
  {$IFDEF Windows}
    {$if defined(cpu64)}
      PA_FileName := ordir + 'lib\Windows\64bit\LibPortaudio-64.dll';
      MP_FileName := ordir + 'lib\Windows\64bit\LibMpg123-64.dll';
    {$else}
      PA_FileName := ordir + 'lib\Windows\32bit\LibPortaudio-32.dll';
      MP_FileName := ordir + 'lib\Windows\32bit\LibMpg123-32.dll';
   {$endif}
  {$ENDIF}

  {$IFDEF linux}
    {$if defined(cpu64)}
      PA_FileName := ordir + 'lib/Linux/64bit/LibPortaudio-64.so';
      MP_FileName := ordir + 'lib/Linux/64bit/LibMpg123-64.so';
    {$else}
      PA_FileName := ordir + 'lib/Linux/32bit/LibPortaudio-32.so';
      MP_FileName := ordir + 'lib/Linux/32bit/LibMpg123-32.so';
    {$endif}
  {$ENDIF}
uos_LoadLib(Pchar(PA_FileName), nil, pchar(MP_FileName), nil);
end;
procedure TFrmFreesControl.TbxTimeClick(Sender: TObject);
begin
if DblClk then begin TbxTimeDblClick(Sender); exit; end;
end;
procedure TFrmFreesControl.FormDestroy(Sender: TObject);
begin
	uos_UnloadLib(); // for release dynamic loaded libraries
        sleep (1000);  // tijd om het geluidje af te maken
end;
procedure TFrmFreesControl.FormCreate(Sender: TObject); // Startup
begin
  InitAudio;
  if ParamStr(1) = 'H' then HideCursors (true) else HideCursors (false);
  if Paramstr(2) = 'ZeroAll' then ZeroAll := 12 else ZeroAll := 0;
  FrmFreesControl.Top := 0;
  FrmFreesControl.Left := 60;
  FrmDiagnose.Top := 0;
  FrmDiagnose.Left := 545;
  FrmDiagnose.Caption:= 'Diagnose.    versie' + VersieString;
  {$IFDEF linux}
		// The linux version appears to position the controls in a GroupBox
		// according to the Fontsize of the GroupBox title.
		// In windows the positions are relative to the box's outline.
		ShiftControlsInGroupBoxes := -10; // so we need to shift them in Linux
		ButtKoelMode.top := ButtKoelmode.top + ShiftControlsInGroupBoxes;
		ButtKoelDebiet.top := ButtKoelDebiet.top + ShiftControlsInGroupBoxes;
		ButtVoedingPlus.top := ButtVoedingPlus.top + ShiftControlsInGroupBoxes;
		ButtVoedingMin.top := ButtVoedingMin.top + ShiftControlsInGroupBoxes;
		ButtVoedingMode.top := ButtVoedingmode.top + ShiftControlsInGroupBoxes;
		TbxVoeding.top := TbxVoeding.top + ShiftControlsInGroupBoxes;
		ButtSpindelDir.top := ButtSpindelDir.top + ShiftControlsInGroupBoxes;
		ButtSpindelSpeed1.top := ButtSpindelSpeed1.top + ShiftControlsInGroupBoxes;
		ButtSpindelSpeed2.top := ButtSpindelSpeed2.top + ShiftControlsInGroupBoxes;
		ButtSpindelBrake.top := ButtSpindelBrake.top + ShiftControlsInGroupBoxes;
  {$ENDIF}

  RemoteIp := '192.168.2.40'; // Arduino in Control Cabinet
  SetUpUDP;
  SelectAxis (AxX);
  VoedingMode := vmWiel;
  EnableButtons(False);
  VoedingIndex := 0;
  EvalVoedingIndex (VoedingIndex);
  FakeMode := 0;
  sp_normal := Tpicture.create;
  sp_black := Tpicture.create;
  sp_red := Tpicture.create;
  sp_normal.LoadFromFile ('sp_normal.bmp');
  sp_black.LoadFromFile ('sp_black.bmp');
  sp_red.LoadFromFile ('sp_red.bmp');
  ReadData;
  LeesCalibratie;
  TandwielMode := false;
end;
end.

