unit u_tandwielen;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls;

type

  { TFrmTandwielen }

  TFrmTandwielen = class(TForm)
    ButtExit: TButton;
    ButtVorigeTand: TButton;
    ButtVolgendeTand: TButton;
    ButtTerug: TButton;
    TbxTandTeMaken: TStaticText;
    TbxAantalTanden: TStaticText;
    Label1: TLabel;
    TimerUpdateTandwielen: TTimer;
    procedure ButtExitClick(Sender: TObject);
    procedure ButtVolgendeTandClick(Sender: TObject);
    procedure ButtVorigeTandClick(Sender: TObject);
    procedure SetAantalTanden (Aantal:integer);
    procedure FormCreate(Sender: TObject);
    procedure TimerUpdateTandwielenTimer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  FrmTandwielen: TFrmTandwielen;
  AantalTanden, TandTemaken: integer;
  Hoek: real;

implementation
{$R *.lfm}
uses u_panel, MyStrings;

procedure Display;
begin
  FrmTandwielen.TbxAantalTanden.caption := FormatN30(AantalTanden);
  FrmTandwielen.TbxTandTeMaken.caption := FormatN30(TandTeMaken);
  Hoek := 360 / AantalTanden * (TandTeMaken - 1);
  FrmFreesControl.SetR_asDoelPositie (Hoek);
end;

procedure TFrmTandwielen.ButtVolgendeTandClick(Sender: TObject);
begin
  Sound_click;
  inc (TandTemaken);
  if TandTeMaken > AantalTanden then TandTeMaken := 1;
  Display;
  ZetVoedingAan := true;
end;

procedure TFrmTandwielen.ButtVorigeTandClick(Sender: TObject);
begin
  Sound_click;
  dec(TandTeMaken);
  if TandTemaken < 1 then TandTeMaken := AantalTanden;
  Display;
  ZetVoedingAan := true;
end;

procedure TFrmTandwielen.FormCreate(Sender: TObject);
begin
  FrmTandwielen.Visible := false;
  TandTemaken := 1;
  Display;
  ZetVoedingAan := true;
end;

procedure TFrmTandwielen.SetAantalTanden (Aantal:integer);
begin
  AantalTanden := Aantal;
  TandTemaken := 1;
  Display
end;

procedure TFrmTandwielen.TimerUpdateTandwielenTimer(Sender: TObject);
begin
  // disable buttons zolang de voeding loopt
  if VoedingIsAan then
  begin
  	ButtVorigeTand.Enabled := false;
  	ButtVolgendeTand.Enabled := false;
    ButtExit.enabled := false;
    end
  else
  begin
  	ButtVorigeTand.Enabled := true;
  	ButtVolgendeTand.Enabled := true;
    ButtExit.enabled := true;
  end;
end;

procedure TFrmTandwielen.ButtExitClick(Sender: TObject);
begin
  Sound_click;
  FrmTandwielen.visible := false;
  FrmFreesControl.FormStyle := fsSystemStayOnTop;
  EnableButtons(true);
  Display;
  TandwielMode := false;
end;

end.

